#!%%SH%%

EXTRA_MIBS=""
if [ "$1" = "-m" ] ; then
   EXTRA_MIBS="-m $2"
   shift 2
   fi

PORT=161
if [ "$1" = "-p" ] ; then
   PORT=$2
   shift 2
   fi

COMMUNITY="public"
if [ "$1" = "-c" ] ; then
   COMMUNITY="$2"
   shift 2
   fi

if [ $# -gt 2 -o $# -eq 0 ] ; then
   echo "Usage: crea_conf.sh [-m extra-mibs] [-p port] [-c comm] host [oid]"
   exit
   fi

MIBS="-v 1 -m all $EXTRA_MIBS"
MIBS="-Ob -Ou $MIBS"

HOST=$1
MIB=$2

rm -rf tmp/$HOST
mkdir -p tmp/$HOST

#
# configurations for 'normal' OID
#

cat <<EOF > /tmp/base.$$

BaseStep 600

AVERAGE 288

TimeStep 6
AVERAGE 1480
MIN 1480
MAX 1480

TimeStep 24
AVERAGE 730
MIN 730
MAX 730

AVERAGE 7 312
MIN 7 312
MAX 7 312

EOF

#echo snmpwalk $MIBS -c $COMMUNITY $HOST:$PORT $MIB
snmpwalk $MIBS -c $COMMUNITY $HOST:$PORT $MIB | tee /tmp/snmpout.$$ \
  | sed -n -e '/Table\./ d' \
      -e 's/^\(.*\)\.\([^\.]*\)\.0 = \(\([^:]*\): \)\?\([A-Za-z][-A-Za-z]*([0-9][0-9]*)\)\?.*$/\1 \2 \4_\5/p' \
  | while read file oid comment ; do
      [ -f tmp/$HOST/$file ] || cp /tmp/base.$$ tmp/$HOST/$file
      echo "[$oid] $oid $comment" >> tmp/$HOST/$file
      done

##
## Configuration for tables
##

sed -n 's/^\(.*\)\.\([^\.]*Table\)\.[^\.]*Entry\.\([^\.]*\)\.\([^ ]*\) = \(\([^:]*\): \)\?\([A-Za-z][-A-Za-z]*([0-9][0-9]*)\)\?.*$/\1 \2 \3 \4 \6_\7/p' /tmp/snmpout.$$ \
  | awk '
function printIdx() {
   indexes=""
   for ( i in idx ) { indexes=sprintf("%s %s",indexes,i) }
   if ( indexes != "" ) { printf "T '$HOST'%s\n\n" , indexes >> outchann }
   delete idx
   }
file[$1,$2] != 1 {
   printIdx()
   command=sprintf("cp /tmp/base.'$$' tmp/'$HOST'/%s.%s",$1,$2)
   system(command)
   outchann=sprintf("tmp/'$HOST'/%s.%s",$1,$2)
   file[$1,$2] = 1
   }
ds[$3] != 1 {
   printf "[%s] %s %s\n" , $3 , $3 , $5 >> outchann
   ds[$3] = 1
   }
{ idx[$4] = 1 }
END { printIdx() }
'

rm /tmp/snmpout.$$ /tmp/base.$$


